@echo off
set casper_exists=-1
set bootloader_exists=0
set source=0
set cd2usb_version=0.6.1
set ubuntu_latest_ver=10.04
set ubuntu_url=http://releases.ubuntu.com/10.04/ubuntu-10.04-desktop-i386.iso
set ubuntu_file_name=ubuntu-10.04-desktop-i386.iso
REM "running_from_cd" can be "true" or "false" (no quotes)
set running_from_cd=false
set download=0
set /P launcher_location=<%TEMP%\cd2usb_location.txt
del "%TEMP%\cd2usb_location.txt"
REM The /D parameter must be used because we are changing drive
cd /D %launcher_location%
REM "interface_mode" can be "gui" or "cli" (no quotes), cli mode might be useful for inclusion on other scripts/programs
REM But I am unsure if it will run on systems without a graphical system due to the "UAC trigger", a manifiest on the .exe
set interface_mode=gui
set PATH=%PATH%;%launcher_location%\backend_cd2usb\zenity\bin
set ZENITY_DATADIR=%launcher_location%\backend_cd2usb\zenity\share\

cd "%launcher_location%"

if %interface_mode% == gui goto intro_gui
if %interface_mode% == cli goto intro_cli

:intro_gui
cls
echo Note: Closing this window will close cd2usb
zenity --title "cd2usb" --info --text "cd2usb %cd2usb_version% from hacktolive.org/cd2usb\n\nUtility designed to make Live USBs of Ubuntu (and Super OS)\n\nLive USB: Operating system than can be booted from a USB flash drive\n\ncd2usb can create bootable HDDs, USB Flash drives, memory cards, etc..."
goto menu_gui

:menu_gui
if %running_from_cd% == true goto choose_usb_drive_gui
zenity --title cd2usb --width=420 --height=210 --text="Choose one option:" --list --radiolist --hide-column=2 --column="Select" ^
 --column="Code" --column="Description" FALSE "cd" "Use a CD/DVD of Ubuntu" FALSE "iso" "Use an ISO of Ubuntu" FALSE "download" ^
  "Automatically download an ISO of Ubuntu %ubuntu_latest_ver%">%TEMP%\cd2usb_option_menu.txt
set /P option_menu=<"%TEMP%\cd2usb_option_menu.txt"
del "%TEMP%\cd2usb_option_menu.txt"
if %option_menu% == cd set source=user_cd
if %option_menu% == cd goto choose_cd_drive_gui
if %option_menu% == iso set source=iso
if %option_menu% == iso goto get_iso_gui
if %option_menu% == download set source=iso
if %option_menu% == download goto download_iso_gui
echo "No option selected or there was some error... exiting..."
exit

:get_iso_gui
zenity --title "cd2usb" --file-selection > "%TEMP%\cd2usb_file_selection.txt"
set /P file_selection=<"%TEMP%\cd2usb_file_selection.txt"
del "%TEMP%\cd2usb_file_selection.txt"
goto check_iso_gui

:download_iso_gui
set download=1
if exist %ubuntu_file_name% del %ubuntu_file_name%
if exist os.iso goto duplicated_iso_found_gui
backend_cd2usb\wget\wget.exe %ubuntu_url%
ren %ubuntu_file_name% os.iso
echo Ubuntu was downloaded! It will now be used...
goto check_iso_gui

:duplicated_iso_found_gui
zenity --title cd2usb --width=420 --height=210 --text="A file named os.iso already exists! Do you want to delete it?" ^
 --list --radiolist --hide-column=2 --column="Select" ^
 --column="Code" --column="Action" FALSE "delete" "Yes, delete it and continue the download of a new file" ^
 FALSE "no" "No, exit">"%TEMP%\cd2usb_option_delete_iso.txt"

set /P option_delete_iso=<"%TEMP%\cd2usb_option_delete_iso.txt"
del "%TEMP%\cd2usb_option_delete_iso.txt"
if %option_delete_iso% == delete del os.iso
if %option_delete_iso% == delete goto download_iso_gui
if %option_delete_iso% == no exit
echo "No option selected or there was some error... exiting..."
exit

:check_iso_gui
if %download% == 1 set file_selection=%launcher_location%os.iso
if exist "%file_selection%" goto choose_usb_drive_gui
zenity --error --text "ISO not found, exiting now..."
exit

:choose_cd_drive_gui
zenity --title cd2usb --width=420 --height=400 --text="Enter the letter of the CD/DVD Drive of Ubuntu:" ^
 --list --radiolist --column="Select" --column="Drive" ^
 FALSE "A" ^
 FALSE "B" ^
 FALSE "C" ^
 FALSE "D" ^
 FALSE "E" ^
 FALSE "F" ^
 FALSE "G" ^
 FALSE "H" ^
 FALSE "I" ^
 FALSE "J" ^
 FALSE "K" ^
 FALSE "L" ^
 FALSE "M" ^
 FALSE "N" ^
 FALSE "O" ^
 FALSE "P" ^
 FALSE "Q" ^
 FALSE "R" ^
 FALSE "S" ^
 FALSE "T" ^
 FALSE "U" ^
 FALSE "V" ^
 FALSE "W" ^
 FALSE "X" ^
 FALSE "Y" ^
 FALSE "Z">"%TEMP%\cd2usb_cd_drive.txt"

set /P cd_drive=<"%TEMP%\cd2usb_cd_drive.txt"
del "%TEMP%\cd2usb_cd_drive.txt"
if %cd_drive% == A goto choose_usb_drive_gui
if %cd_drive% == B goto choose_usb_drive_gui
if %cd_drive% == C goto choose_usb_drive_gui
if %cd_drive% == D goto choose_usb_drive_gui
if %cd_drive% == E goto choose_usb_drive_gui
if %cd_drive% == F goto choose_usb_drive_gui
if %cd_drive% == G goto choose_usb_drive_gui
if %cd_drive% == H goto choose_usb_drive_gui
if %cd_drive% == I goto choose_usb_drive_gui
if %cd_drive% == J goto choose_usb_drive_gui
if %cd_drive% == K goto choose_usb_drive_gui
if %cd_drive% == L goto choose_usb_drive_gui
if %cd_drive% == M goto choose_usb_drive_gui
if %cd_drive% == N goto choose_usb_drive_gui
if %cd_drive% == O goto choose_usb_drive_gui
if %cd_drive% == P goto choose_usb_drive_gui
if %cd_drive% == Q goto choose_usb_drive_gui
if %cd_drive% == R goto choose_usb_drive_gui
if %cd_drive% == S goto choose_usb_drive_gui
if %cd_drive% == T goto choose_usb_drive_gui
if %cd_drive% == U goto choose_usb_drive_gui
if %cd_drive% == V goto choose_usb_drive_gui
if %cd_drive% == W goto choose_usb_drive_gui
if %cd_drive% == X goto choose_usb_drive_gui
if %cd_drive% == Y goto choose_usb_drive_gui
if %cd_drive% == Z goto choose_usb_drive_gui

echo "No option selected or there was some error... exiting..."
exit

:choose_usb_drive_gui
zenity --title cd2usb --width=420 --height=400 --text="Enter the letter of the target USB Drive:" ^
 --list --radiolist --column="Select" --column="Drive" ^
 FALSE "A" ^
 FALSE "B" ^
 FALSE "C" ^
 FALSE "D" ^
 FALSE "E" ^
 FALSE "F" ^
 FALSE "G" ^
 FALSE "H" ^
 FALSE "I" ^
 FALSE "J" ^
 FALSE "K" ^
 FALSE "L" ^
 FALSE "M" ^
 FALSE "N" ^
 FALSE "O" ^
 FALSE "P" ^
 FALSE "Q" ^
 FALSE "R" ^
 FALSE "S" ^
 FALSE "T" ^
 FALSE "U" ^
 FALSE "V" ^
 FALSE "W" ^
 FALSE "X" ^
 FALSE "Y" ^
 FALSE "Z">"%TEMP%\cd2usb_usb_drive.txt"

set /P usb_drive=<"%TEMP%\cd2usb_usb_drive.txt"
del "%TEMP%\cd2usb_usb_drive.txt"
if %usb_drive% == A goto choose_casper-rw_size_gui
if %usb_drive% == B goto choose_casper-rw_size_gui
if %usb_drive% == C goto choose_casper-rw_size_gui
if %usb_drive% == D goto choose_casper-rw_size_gui
if %usb_drive% == E goto choose_casper-rw_size_gui
if %usb_drive% == F goto choose_casper-rw_size_gui
if %usb_drive% == G goto choose_casper-rw_size_gui
if %usb_drive% == H goto choose_casper-rw_size_gui
if %usb_drive% == I goto choose_casper-rw_size_gui
if %usb_drive% == J goto choose_casper-rw_size_gui
if %usb_drive% == K goto choose_casper-rw_size_gui
if %usb_drive% == L goto choose_casper-rw_size_gui
if %usb_drive% == M goto choose_casper-rw_size_gui
if %usb_drive% == N goto choose_casper-rw_size_gui
if %usb_drive% == O goto choose_casper-rw_size_gui
if %usb_drive% == P goto choose_casper-rw_size_gui
if %usb_drive% == Q goto choose_casper-rw_size_gui
if %usb_drive% == R goto choose_casper-rw_size_gui
if %usb_drive% == S goto choose_casper-rw_size_gui
if %usb_drive% == T goto choose_casper-rw_size_gui
if %usb_drive% == U goto choose_casper-rw_size_gui
if %usb_drive% == V goto choose_casper-rw_size_gui
if %usb_drive% == W goto choose_casper-rw_size_gui
if %usb_drive% == X goto choose_casper-rw_size_gui
if %usb_drive% == Y goto choose_casper-rw_size_gui
if %usb_drive% == Z goto choose_casper-rw_size_gui

goto usb_drive_error_gui

:usb_drive_error_gui
zenity --error --text "That drive letter is not valid... Exiting..."
exit

:choose_casper-rw_size_gui
zenity --title cd2usb --width=420 --height=350 ^
 --text="Select the size of the persistency file:\nNote: only works with Ubuntu 8.10+\nNote: Bigger sizes are not possible due to limitations of the FAT filesystem" ^
 --list --radiolist --hide-column=2 --column="Select" ^
 --column="Code" --column="Description" ^
 FALSE "0" "No persistence file" ^
 FALSE "128" "128 MB (not recommended, too small)" ^
 FALSE "256" "256 MB" ^
 FALSE "512" "512 MB" ^
 FALSE "1024" "1 GB" ^
 FALSE "2048" "2 GB" ^
 FALSE "3072" "3 GB" ^
 FALSE "4096" "4 GB">"%TEMP%\cd2usb_casper-rw_size.txt"

set /P casper-rw_size=<"%TEMP%\cd2usb_casper-rw_size.txt"
del "%TEMP%\cd2usb_casper-rw_size.txt"
if %casper-rw_size% == 0 set casper_exists=0
if %casper-rw_size% == 128 set casper_exists=1
if %casper-rw_size% == 256 set casper_exists=1
if %casper-rw_size% == 512 set casper_exists=1
if %casper-rw_size% == 1024 set casper_exists=1
if %casper-rw_size% == 2048 set casper_exists=1
if %casper-rw_size% == 3072 set casper_exists=1
if %casper-rw_size% == 4096 set casper_exists=1
if %casper_exists% == 0 goto confirmation_gui
if %casper_exists% == 1 goto confirmation_gui
goto error_casper-rw_size_gui

:error_casper-rw_size_gui
zenity --error --text "That size is not valid... Exiting..."
exit

:confirmation_gui
if %casper_exists% == 1 set text_for_zenity="With a persistence file of %casper-rw_size% MB"
if %casper_exists% == 0 set text_for_zenity="With no persistence file"
zenity --title cd2usb --text "Ubuntu will now be installed on the drive %usb_drive%:\nDo you want to continue?" ^
 --list --radiolist --hide-column=2 --column="Select" ^
 --column="Code" --column="Description" ^
 FALSE "yes" "Yes" FALSE "no" "No, exit">"%TEMP%\cd2usb_option_confirmation.txt"

set /P option_confirmation=<"%TEMP%\cd2usb_option_confirmation.txt"
del "%TEMP%\cd2usb_option_confirmation.txt"
if %option_confirmation% == yes goto make_bootable
if %option_confirmation% == no exit


REM The CLI part of the interface starts here

:intro_cli
cls
echo =======================================
echo       cd2usb %cd2usb_version% from hacktolive.org/cd2usb
echo.
echo =======================================
echo.
echo.
echo Utility designed to make Live USBs of Ubuntu (and Super OS)
echo Live USB: Operating system than can be booted from a USB flash drive
echo cd2usb can create bootable HDDs, USB Flash drives, memory cards, etc...
echo.
pause
goto menu_cli

:menu_cli
if %running_from_cd% == true goto choose_usb_drive_cli
cls
echo Options:
echo 1 - Do you want to use a CD/DVD of Ubuntu you already have?
echo 2 - Do you want to use an ISO of Ubuntu you already have?
echo 3 - Do you want cd2usb to automatically download an ISO of Ubuntu %ubuntu_latest_ver%?
echo.
echo Enter the option you want (1, 2 or 3) and press ENTER:
set /p option_menu=
if %option_menu% == 1 set source=user_cd
if %option_menu% == 1 goto choose_cd_drive_cli
if %option_menu% == 2 set source=iso
if %option_menu% == 2 goto get_iso_cli
if %option_menu% == 3 set download=1
if %option_menu% == 3 set source=iso
if %option_menu% == 3 goto download_iso_cli
echo Option not valid!
pause
goto menu_cli

:get_iso_cli
cls
echo Please place a file named "os.iso" on the folder of cd2usb ( %launcher_location% ) and then press ENTER
pause
set file_selection=%launcher_location%\os.iso
goto check_iso_cli

:download_iso_cli
cls
echo Ubuntu %ubuntu_latest_ver% will now be downloaded...
echo.
if exist %ubuntu_file_name% del %ubuntu_file_name%
if exist os.iso goto duplicated_iso_found_cli
backend_cd2usb\wget\wget.exe %ubuntu_url%
ren %ubuntu_file_name% os.iso
echo Ubuntu was downloaded! It will now be used...
pause
goto check_iso_cli

:duplicated_iso_found_cli
cls
echo A file named os.iso already exists! Do you want to delete it?
echo 1 - Yes, delete it and continue the download of a new file
echo 2 - No, go back
echo.
echo Enter the option you want (1 or 2) and press ENTER:
set /p option_delete_iso=
if %option_delete_iso% == 1 del os.iso
if %option_delete_iso% == 1 goto download_iso_cli
if %option_delete_iso% == 2 goto menu_cli
echo Option not valid!
pause
goto duplicated_iso_found_cli

:check_iso_cli
cls
if %download% == 1 set file_selection="%launcher_location%\os.iso"
if exist %file_selection% (
if %download% == 0 echo A file named os.iso was found! It will now be used...
echo.
goto choose_usb_drive_cli)
goto iso_error_cli

:iso_error_cli
echo The file "os.iso" was not found!
echo.
echo You must place a file named os.iso
echo in the folder were this program is
echo.
pause
echo.
goto menu_cli

:choose_cd_drive_cli
echo.
echo.
echo.
echo Enter the letter of the CD/DVD Drive of Ubuntu (A - Z):
set /p cd_drive=
if %cd_drive% == A goto choose_usb_drive_cli
if %cd_drive% == B goto choose_usb_drive_cli
if %cd_drive% == C goto choose_usb_drive_cli
if %cd_drive% == D goto choose_usb_drive_cli
if %cd_drive% == E goto choose_usb_drive_cli
if %cd_drive% == F goto choose_usb_drive_cli
if %cd_drive% == G goto choose_usb_drive_cli
if %cd_drive% == H goto choose_usb_drive_cli
if %cd_drive% == I goto choose_usb_drive_cli
if %cd_drive% == J goto choose_usb_drive_cli
if %cd_drive% == K goto choose_usb_drive_cli
if %cd_drive% == L goto choose_usb_drive_cli
if %cd_drive% == M goto choose_usb_drive_cli
if %cd_drive% == N goto choose_usb_drive_cli
if %cd_drive% == O goto choose_usb_drive_cli
if %cd_drive% == P goto choose_usb_drive_cli
if %cd_drive% == Q goto choose_usb_drive_cli
if %cd_drive% == R goto choose_usb_drive_cli
if %cd_drive% == S goto choose_usb_drive_cli
if %cd_drive% == T goto choose_usb_drive_cli
if %cd_drive% == U goto choose_usb_drive_cli
if %cd_drive% == V goto choose_usb_drive_cli
if %cd_drive% == W goto choose_usb_drive_cli
if %cd_drive% == X goto choose_usb_drive_cli
if %cd_drive% == Y goto choose_usb_drive_cli
if %cd_drive% == Z goto choose_usb_drive_cli
if %cd_drive% == a goto choose_usb_drive_cli
if %cd_drive% == b goto choose_usb_drive_cli
if %cd_drive% == c goto choose_usb_drive_cli
if %cd_drive% == d goto choose_usb_drive_cli
if %cd_drive% == e goto choose_usb_drive_cli
if %cd_drive% == f goto choose_usb_drive_cli
if %cd_drive% == g goto choose_usb_drive_cli
if %cd_drive% == h goto choose_usb_drive_cli
if %cd_drive% == i goto choose_usb_drive_cli
if %cd_drive% == j goto choose_usb_drive_cli
if %cd_drive% == k goto choose_usb_drive_cli
if %cd_drive% == l goto choose_usb_drive_cli
if %cd_drive% == m goto choose_usb_drive_cli
if %cd_drive% == n goto choose_usb_drive_cli
if %cd_drive% == o goto choose_usb_drive_cli
if %cd_drive% == p goto choose_usb_drive_cli
if %cd_drive% == q goto choose_usb_drive_cli
if %cd_drive% == r goto choose_usb_drive_cli
if %cd_drive% == s goto choose_usb_drive_cli
if %cd_drive% == t goto choose_usb_drive_cli
if %cd_drive% == u goto choose_usb_drive_cli
if %cd_drive% == v goto choose_usb_drive_cli
if %cd_drive% == w goto choose_usb_drive_cli
if %cd_drive% == x goto choose_usb_drive_cli
if %cd_drive% == y goto choose_usb_drive_cli
if %cd_drive% == z goto choose_usb_drive_cli
goto cd_drive_error_cli

:cd_drive_error_cli
cls
echo That drive letter is not valid...
echo.
pause
goto choose_cd_drive_cli

:choose_usb_drive_cli
echo.
echo.
echo.
echo Enter the letter of the USB Flash Drive (A - Z):
set /p usb_drive=
if %usb_drive% == A goto choose_casper-rw_size_cli
if %usb_drive% == B goto choose_casper-rw_size_cli
if %usb_drive% == C goto choose_casper-rw_size_cli
if %usb_drive% == D goto choose_casper-rw_size_cli
if %usb_drive% == E goto choose_casper-rw_size_cli
if %usb_drive% == F goto choose_casper-rw_size_cli
if %usb_drive% == G goto choose_casper-rw_size_cli
if %usb_drive% == H goto choose_casper-rw_size_cli
if %usb_drive% == I goto choose_casper-rw_size_cli
if %usb_drive% == J goto choose_casper-rw_size_cli
if %usb_drive% == K goto choose_casper-rw_size_cli
if %usb_drive% == L goto choose_casper-rw_size_cli
if %usb_drive% == M goto choose_casper-rw_size_cli
if %usb_drive% == N goto choose_casper-rw_size_cli
if %usb_drive% == O goto choose_casper-rw_size_cli
if %usb_drive% == P goto choose_casper-rw_size_cli
if %usb_drive% == Q goto choose_casper-rw_size_cli
if %usb_drive% == R goto choose_casper-rw_size_cli
if %usb_drive% == S goto choose_casper-rw_size_cli
if %usb_drive% == T goto choose_casper-rw_size_cli
if %usb_drive% == U goto choose_casper-rw_size_cli
if %usb_drive% == V goto choose_casper-rw_size_cli
if %usb_drive% == W goto choose_casper-rw_size_cli
if %usb_drive% == X goto choose_casper-rw_size_cli
if %usb_drive% == Y goto choose_casper-rw_size_cli
if %usb_drive% == Z goto choose_casper-rw_size_cli
if %usb_drive% == a goto choose_casper-rw_size_cli
if %usb_drive% == b goto choose_casper-rw_size_cli
if %usb_drive% == c goto choose_casper-rw_size_cli
if %usb_drive% == d goto choose_casper-rw_size_cli
if %usb_drive% == e goto choose_casper-rw_size_cli
if %usb_drive% == f goto choose_casper-rw_size_cli
if %usb_drive% == g goto choose_casper-rw_size_cli
if %usb_drive% == h goto choose_casper-rw_size_cli
if %usb_drive% == i goto choose_casper-rw_size_cli
if %usb_drive% == j goto choose_casper-rw_size_cli
if %usb_drive% == k goto choose_casper-rw_size_cli
if %usb_drive% == l goto choose_casper-rw_size_cli
if %usb_drive% == m goto choose_casper-rw_size_cli
if %usb_drive% == n goto choose_casper-rw_size_cli
if %usb_drive% == o goto choose_casper-rw_size_cli
if %usb_drive% == p goto choose_casper-rw_size_cli
if %usb_drive% == q goto choose_casper-rw_size_cli
if %usb_drive% == r goto choose_casper-rw_size_cli
if %usb_drive% == s goto choose_casper-rw_size_cli
if %usb_drive% == t goto choose_casper-rw_size_cli
if %usb_drive% == u goto choose_casper-rw_size_cli
if %usb_drive% == v goto choose_casper-rw_size_cli
if %usb_drive% == w goto choose_casper-rw_size_cli
if %usb_drive% == x goto choose_casper-rw_size_cli
if %usb_drive% == y goto choose_casper-rw_size_cli
if %usb_drive% == z goto choose_casper-rw_size_cli
goto usb_drive_error_cli

:usb_drive_error_cli
cls
echo That drive letter is not valid...
echo.
pause
goto choose_usb_drive_cli

:choose_casper-rw_size_cli
cls
echo Select the size of the persistency file,
echo it must be an exact value in this list:
echo.
echo      0  (no file will be created)
echo      128 MB (not recommended, too small)
echo      256 MB
echo      512 MB
echo      1024 MB  (1 GB)
echo      2048 MB  (2 GB)
echo      3072 MB  (3 GB)
echo      4096 MB  (4 GB)
echo.
echo Note: only works with Ubuntu 8.10+
echo Note: Bigger sizes are not possible due to limitations of the FAT filesystem
echo.
echo Size (in MB):
set /p casper-rw_size=
if %casper-rw_size% == 0 set casper_exists=0
if %casper-rw_size% == 128 set casper_exists=1
if %casper-rw_size% == 256 set casper_exists=1
if %casper-rw_size% == 512 set casper_exists=1
if %casper-rw_size% == 1024 set casper_exists=1
if %casper-rw_size% == 2048 set casper_exists=1
if %casper-rw_size% == 3072 set casper_exists=1
if %casper-rw_size% == 4096 set casper_exists=1
if %casper_exists% == 0 goto confirmation_cli
if %casper_exists% == 1 goto confirmation_cli
goto error_casper-rw_size_cli

:error_casper-rw_size_cli
cls
echo.
echo  That size is not valid! Let's try again...
echo.
pause
goto choose_casper-rw_size_cli

:confirmation_cli
cls
echo Ubuntu will now be installed on the drive %usb_drive%
if %casper_exists% == 1 echo With a persistence file of %casper-rw_size% MB
if %casper_exists% == 0 echo With no persistence file
echo.
echo Do you want to continue?
echo 1 - Yes
echo 2 - No (go back to main menu)
echo.
echo Enter the option you want (1 or 2) and press ENTER:
set /p option_confirmation=
if %option_confirmation% == 1 goto make_bootable
if %option_confirmation% == 2 goto menu_cli
echo Option not valid!
pause
goto confirmation_cli
echo.

:make_bootable
echo Files will now be copied to the USB device...
echo.
if %source% == iso backend_cd2usb\7-Zip\7z.exe x "%file_selection%" -y -x!bin -x!programs -x![BOOT] -o%usb_drive%:
if %source% == iso echo Finished extracting files from the ISO...
if %source% == user_cd backend_cd2usb\robocopy\robocopy.exe %cd_drive%: %usb_drive%: /E
if %source% == user_cd echo Finished copying files from the CD/DVD...
if %running_from_cd% == true backend_cd2usb\robocopy\robocopy.exe . %usb_drive%: /E
if %running_from_cd% == true echo Finished copying files from the CD/DVD...
echo Moving and renaming some files...
ren %usb_drive%:\isolinux syslinux
xcopy %launcher_location%\backend_cd2usb\syslinux_ubuntumrt_fixed.cfg %usb_drive%:\syslinux\ /I /Y
if %casper_exists% == 0 ren %usb_drive%:\syslinux\isolinux.cfg syslinux.cfg
if %casper_exists% == 1 ren %usb_drive%:\syslinux\syslinux_ubuntumrt_fixed.cfg syslinux.cfg
ATTRIB -R %usb_drive%:\syslinux\text.cfg

REM We now need to detect the format of the initrd package in the "casper" folder
REM Comment In Ubuntu 9.04 or older the format is "initrd.gz", but in Ubuntu 9.10 or newer it is "initrd.lz" (at least Ub. 10.04)
set text_cfg_format=none
if exist %usb_drive%:\casper\initrd.gz set text_cfg_format=text_for_initrd.gz_Ubuntu_9.04_or_older.cfg
if exist %usb_drive%:\casper\initrd.lz set text_cfg_format=text_for_initrd.lz_Ubuntu_9.10_or_newer.cfg
if %text_cfg_format% == none goto initrd_error
REM ###TODO###: Check contens of the casper folder to make this more "future-proof" (example: initrd.tar.gz)

copy backend_cd2usb\text\%text_cfg_format% %usb_drive%:\syslinux\text.cfg
echo Finished moving and renaming files...
echo The bootloader will now be installed...
backend_cd2usb\syslinux\syslinux.exe -m -a -f %usb_drive%:
if exist %usb_drive%:\ldlinux.sys set bootloader_exists=1
if %bootloader_exists%== 1 echo Bootloader installed successfully!
if %bootloader_exists%== 0 echo There was an error installing the bootloader!
if %casper_exists% == 1 echo The persistence file will now be created...
if %casper_exists% == 1 backend_cd2usb\7-Zip\7z.exe x backend_cd2usb\casper-rw\%casper-rw_size%.7z -y -o%usb_drive%:
if %casper_exists% == 1 echo Finished creating persistence file...
echo.
echo.
echo.
echo.
echo If you see no errors above, it is time to test your Live USB!
echo All finished here!
if %download% == 1 echo You might want to delete the ISO of Ubuntu that was automatically downloaded,
if %download% == 1 echo it is located at %CD%
goto finish

:initrd_error
echo.
if %interface_mode% == gui zenity --title cd2usb --info --text "ERROR: neither initrd.gz nor initrd.lz found\nYour distro/OS is probably not supported..."
if %interface_mode% == cli echo ERROR: neither initrd.gz nor initrd.lz found
if %interface_mode% == cli echo Your distro/OS is probably not supported...
goto finish

:finish
echo.
echo All finished here... You can now close this window...
if %interface_mode% == gui zenity --title cd2usb --info --text "The operation is completed.\nIf you see no erros on the command line, you can now try your Live USB"
pause > nul